// dlfunc.cc

#include <iostream>
#include <strstream>
#include <string>
#include <vector>
#include <algorithm>
#include <stdlib.h>
#include <stdio.h>

#include <sys/types.h> // opendir()
#include <dirent.h>    //

#include <sys/stat.h>  // mkdir()
#include <fcntl.h>
#include <unistd.h> // getpid, execl

#include <forint/forint_types.hh>
#include <forint/forint.hh>

namespace FInt {

// built-in variables may be overloaded...
bool forint::
is_overloaded(const char* var)
{
  vec_t<uint> a;
  a.getPtr();
  char** name = var_name.getPtr();
  for (uint i=0; i<var_name.size(); i++)
    if (!strcmp(var, name[i]))
      return true;
  return false;
}

// built-in functions may be overloaded...
bool forint::
is_overloaded_func(const char* func)
{
  char** name = usr_function_0_name.getPtr();
  for (uint i=0; i<usr_function_0_name.size(); i++)
    if (!strcmp(func, name[i]))
      return true;
  name = usr_function_1_name.getPtr();
  for (uint i=0; i<usr_function_1_name.size(); i++)
    if (!strcmp(func, name[i]))
      return true;
  name = usr_function_2d_name.getPtr();
  for (uint i=0; i<usr_function_2d_name.size(); i++)
    if (!strcmp(func, name[i]))
      return true;
  name = usr_function_2p_name.getPtr();
  for (uint i=0; i<usr_function_2p_name.size(); i++)
    if (!strcmp(func, name[i]))
      return true;
  name = usr_function_2_name.getPtr();
  for (uint i=0; i<usr_function_2_name.size(); i++)
    if (!strcmp(func, name[i]))
      return true;
  return false;
}

// replace double operands of operators:
//       %,  &,  |,  ^,  <<,  >>, ~,
//       %=, &=, |=, ^=, <<=, >>=.
// new name is old one with prefix '___Ll_', so 
// it is unlikely a new name will coincide with old one sometime,
// later I'll fix this drawback.
// Sun Aug  6 20:30:42 MSD 2000, added `double()' casting of its first operands
map<string, string> old_new_name;
void forint::
insert_long_operands(string& s)
{
  string str;
  uint size = s.size();
  uint b_coun = 0;
  uint e_coun = 0;
  uint ass_coun = 0;
  uint d_b_coun = 0;
  uint d_e_coun = 0;

  sort(b_cast_pos.begin(),b_cast_pos.end());
  sort(e_cast_pos.begin(),e_cast_pos.end());
  sort(d_b_cast_pos.begin(),d_b_cast_pos.end());
  sort(d_e_cast_pos.begin(),d_e_cast_pos.end());

// yes, non-efficient, I'll rewrite it when I'll have enough time
// and if it will be need
  uint k = 0;
  vector<string> name;
  vector<uint> name_pos;
  for (map<uint, string>::iterator it=new_name_pos.begin();
       it != new_name_pos.end(); it++) {
    name_pos.push_back(it->first);
    name.push_back(it->second);
  }
  vector<string> renamed;
  bool is_name;
  for (uint i=0; i < new_name_pos.size(); i++) {
    is_name = false;
    for (k=0; k < renamed.size(); k++)
      if (renamed[k] == name[i]) {
	is_name = true;
	break;
      }
    if (!is_name) {
      char tmp[50];
      ostrstream ostr (tmp,50);
      ostr << "___Ll_" << name[i] << ends;
      renamed.push_back(tmp);
      old_new_name[name[i]] = tmp;
    }
  }

  for (uint i=0;
       i<size ||
	 e_coun < e_cast_pos.size() ||
	 ass_coun < name.size() ||
	 d_e_coun < d_e_cast_pos.size();
       i++) {
    if (b_cast_pos.size() && i == b_cast_pos[b_coun]) {
      str += "Llong(";
      ++b_coun;
    }
    else if (b_cast_pos.size() && i == e_cast_pos[e_coun]) {
      str += ")";
      ++e_coun;
    }
    else if (name_pos.size() && i == name_pos[ass_coun]) {
      str += old_new_name[name[ass_coun]];
      i += name[ass_coun].size() - 1;
      ++ass_coun;
      continue;
    }
    else if (d_b_cast_pos.size() && i == d_b_cast_pos[d_b_coun]) {
      str += "double(";
      ++d_b_coun;
    }
    else if (d_b_cast_pos.size() && i == d_e_cast_pos[d_e_coun]) {
      str += ")";
      ++d_e_coun;
    }
    if (i >= size &&
	e_coun >= e_cast_pos.size() &&
	ass_coun >= name.size() &&
	d_e_coun >= d_e_cast_pos.size()) break;
    str += s[i];
  }

// replace variables to 'long long' twins...
  uint pos=0;
  uint tmp_pos=0;
  for (map<string,string>::iterator it=old_new_name.begin();
       it != old_new_name.end(); it++) {
    string tmp_sub_expr = str;
    pos = 0;
    while ((tmp_pos=tmp_sub_expr.find(it->first)) != string::npos &&
	   (tmp_pos == 0 ||
	    !isalpha(tmp_sub_expr[tmp_pos-1]) &&
	    tmp_sub_expr[tmp_pos-1] != '_') &&
	   (tmp_pos+strlen(it->first.c_str()) == tmp_sub_expr.size() ||
	    !isalpha(tmp_sub_expr[tmp_pos+it->first.size()]) &&
	    tmp_sub_expr[tmp_pos+it->first.size()] != '_')) {
      str.replace(tmp_pos+pos,it->first.size(),it->second);
      pos += tmp_pos + it->second.size();
      tmp_sub_expr = str.substr(pos,str.size()-pos);
    }
  }
  s = str;
}

// make temporary .cc file from a formula and compile it in a temporaty .so
// file, return 0 if no errors have been occured...
int forint::
mk_dl_func(char* expr,
	   char** p_cc_name,
	   char** p_so_name,
	   vector<char*>* dlf_opt)
{
  if (!expr) return 1;
  if (!strlen(expr)) return 1;
  using FInt_internal::cmd;
  using FInt_internal::num_coor;
  FILE* dlf_file;

  string tmp_expr = expr;
  uint pos = 0;
  uint tmp_pos = 0;
  char* ttmp = 0;
  char* ttmp2 = 0;

  for (uint i=(uint)FI_SIN; i<(uint)FI_NOT; i++)
    while ((pos=tmp_expr.find(cmd[i])) != string::npos &&
	   !isalpha(tmp_expr[pos-1]) &&
	   tmp_expr[pos-1] != '_' &&
	   !isalpha(tmp_expr[pos+strlen(cmd[i])]) &&
	   tmp_expr[pos+strlen(cmd[i])] != '_' &&
	   is_overloaded_func(cmd[i])) {
if (!locale) {
      c.err(expr+pos,strlen(cmd[i]),
	    "An overloaded built-in function \'");
      c.err(cmd[i]);
      c.err("\' can't be used in DLF mode.");
} else {
      c.err(expr+pos,strlen(cmd[i]),
	    "   \'");
      c.err(cmd[i]);
      c.err("\'      DLF .");
}
      c.flsh(); 
      error_code = 123;
      return error_code;
    }
  for (uint i=(uint)FI_ATAN2; i<(uint)FI_COND; i++)
    if ((pos=tmp_expr.find(cmd[i])) != string::npos &&
	!isalpha(tmp_expr[pos-1]) &&
	tmp_expr[pos-1] != '_' &&
	!isalpha(tmp_expr[pos+strlen(cmd[i])]) &&
	tmp_expr[pos+strlen(cmd[i])] != '_' &&
	is_overloaded_func(cmd[i])) {
if (!locale) {
      c.err(expr+pos,strlen(cmd[i]),
	    "An overloaded built-in function \'");
      c.err(cmd[i]);
      c.err("\' can't be used in DLF mode.");
} else {
      c.err(expr+pos,strlen(cmd[i]),
	    "   \'");
      c.err(cmd[i]);
      c.err("\'      DLF .");
}
      c.flsh(); 
      error_code = 124;
      return error_code;
    }

  char* cc_name = (char*)malloc(200*sizeof(char));
  char* so_name = (char*)malloc(200*sizeof(char));
  *p_cc_name = cc_name;
  *p_so_name = so_name;
  char* tmp  = (char*)malloc(100*sizeof(char));
  char* default_dir = "/tmp";
  char* env_dir = 0;
  char* dir = default_dir;

  if ((env_dir=getenv("FORINT_TMP_DIR"))) {
    dir = env_dir;
    if (!opendir(dir)) {
      if (errno != ENOENT) {
	fputs ("\nforint: opendir() error\n", stderr);
	fputs (strerror(errno), stderr);
	error_code = 1000;
	return error_code;
      }
      if (mkdir(dir, S_IRUSR | S_IWUSR | S_IXUSR) == -1) {
	fputs ("\nforint: mkdir() error\n", stderr);
	fputs (strerror(errno), stderr);
	error_code = 1000;
	return error_code;
      }
    }
  }

  strcpy(cc_name,dir);
  strcat(cc_name,"/forint.dlf.");
  sprintf(tmp,"%u",getpid());
  strcat(cc_name,tmp);
  strcat(cc_name,".");
  sprintf(tmp,"%u",forint::dl_func_cntr);
  strcat(cc_name,tmp);
  strcat(cc_name,".cc");
  
  strcpy(so_name,dir);
  strcat(so_name,"/forint.dlf.");
  sprintf(tmp,"%u",getpid());
  strcat(so_name,tmp);
  strcat(so_name,".");
  sprintf(tmp,"%u",forint::dl_func_cntr);
  strcat(so_name,tmp);
  strcat(so_name,".so");

  if (!(dlf_file=fopen(cc_name,"w"))) {
    fputs ("\nforint: fopen() error\n", stderr);
    fputs (strerror(errno), stderr);
    error_code = 1000;
    return error_code;
  }
  fprintf(dlf_file,
	  "// forint temporary file,"
	  " please, don't remove this file for a run\n\n"
	  "#include <math.h>\n"
	  "#include <forint/forint.hh>");
	    
  fprintf(dlf_file, "\ntypedef long long Llong;\n\n");
  char** p_p_var_name = var_name.getPtr();
  for (uint i=0; i<variable.size(); i++)
    fprintf(dlf_file,
	    "extern double %s;\n", p_p_var_name[i]);

  poin_t* p_p_poin_type = poin_type.getPtr();
  char** p_p_poin_name = poin_name.getPtr();
  for (uint i=0; i<pointer.size(); i++) {
    if (poin_type.getPtr()[i].num_dims > 1) {
    fprintf(dlf_file,
	    "extern %s %s ",
	    p_p_poin_type[i].poin_type,
	    p_p_poin_name[i]);
    for (uint j=0; j<p_p_poin_type[i].num_dims; j++)
      fprintf(dlf_file,"[%i]",
	      p_p_poin_type[i].dim_size[j]);
    } else {
    fprintf(dlf_file,
	    "extern %s* %s",
	    p_p_poin_type[i].poin_type,
	    p_p_poin_name[i]);
    }
    fprintf(dlf_file, ";\n");
  }

  fprintf(dlf_file, "\n");
  char** p_p_func_0_name = usr_function_0_name.getPtr();
  for (uint i=0; i<usr_function_0.size(); i++)
    fprintf(dlf_file,
	    "double %s (void);\n", p_p_func_0_name[i]);

  char** p_p_func_1_name = usr_function_1_name.getPtr();
  for (uint i=0; i<usr_function_1.size(); i++)
    fprintf(dlf_file,
	    "double %s (double);\n", p_p_func_1_name[i]);

  char** p_p_func_2d_name = usr_function_2d_name.getPtr();
  for (uint i=0; i<usr_function_2d.size(); i++) {
    fprintf(dlf_file,
	    "double %s (double",p_p_func_2d_name[i]);
    fprintf(dlf_file,
	    ", double);\n");
  }
  char** p_p_func_2p_name = usr_function_2p_name.getPtr();
  for (uint i=0; i<usr_function_2p.size(); i++) {
    fprintf(dlf_file,
	    "double %s (void*",p_p_func_2p_name[i]);
    fprintf(dlf_file,
	    ", void*);\n");
  }
  char** p_p_func_2_name = usr_function_2_name.getPtr();
  for (uint i=0; i<usr_function_2.size(); i++) {
    fprintf(dlf_file,
	    "double %s (double",p_p_func_2_name[i]);
    //fprintf(dlf_file,
    //    "%s", p_p_func_2_poin_type[i].poin_type);
    fprintf(dlf_file,
	    ", void*);\n");
  }

// cast array subscript to integer type
  for (uint i=0; i<tmp_expr.size(); i++) {
    if (tmp_expr[i] == '[') {
      tmp_expr.insert(i+1,"Llong(");
      i += strlen("Llong(");
    }
    else if (tmp_expr[i] == ']') {
      tmp_expr.insert(i,")");
      i += strlen(")");
    }
  }


// replace double operands of operators:
//       %, &, |, ^, ~, <<, >>, %=, &=, |=, ^=, <<=, >>=.
  if (b_cast_pos.size() || new_name_pos.size() || d_b_cast_pos.size())
    insert_long_operands(tmp_expr);

  if (flag_of_ctrl_statement_access) {
    ttmp = (char*)tmp_expr.c_str();
    for (unsigned int i=0; i<tmp_expr.size(); i++) {
      if (tmp_expr[i] == 'w' &&
	  (i == 0 || !isalnum(tmp_expr[i-1]) || tmp_expr[i-1] != '_') &&
	  i < tmp_expr.size()-9 &&
	  tmp_expr[1] == 'h' &&
	  tmp_expr[2] == 'i' &&
	  tmp_expr[3] == 'l' &&
	  tmp_expr[4] == 'e') {
	i += strlen("while");
	while (tmp_expr[i] != '(') i++;
	ttmp2 = ttmp += ++i;
	pair(ttmp,tmp_expr.size()-i,'(',')');
	tmp_expr.insert(ttmp-ttmp2," && !break_flag");
      }
    }
  }

/*
let we've compiled function "func(double)" by a g++ compiler, then "func__Fd"
symbol we find in obj code corresponding to the function.
let's consider the symbol. a part before "__" isn't interesting because it
is just the function's name, postfix "__Fd" which appeared in c++ obj code
because of function overloading in C++ consists of two part:
 "__" which is a delimiter of the function's name and argument part, and
 "Fd" which consists of "F" probably meaning "function" and "d" meaning a
      double argument.

examples of symbols for another signatures:
 "func__FPdPPPiPc" -- pointer to double, pointer to pointer to pointer to int,
      pointer to char,
 "func__FPt12basic_string3ZcZt18string_char_traits1ZcZt24__default_alloc_template2b1i0" -- a pointer to string,
 "func__Fv" -- void signature.
 "func__FPvT0" -- two pointers to void (?!).

of course, symbols for pointers and array names have no postfices, because you
can't overload them.
*/
  char** uf_0_name  = usr_function_0_name.getPtr();
  char** uf_1_name  = usr_function_1_name.getPtr();
  char** uf_2d_name = usr_function_2d_name.getPtr();
  char** uf_2p_name = usr_function_2p_name.getPtr();
  char** uf_2_name  = usr_function_2_name.getPtr();
  for (uint i=0; i<usr_function_0_name.size(); i++) {
    string tmp_sub_expr = tmp_expr;
    pos = 0;
    while ((tmp_pos=tmp_sub_expr.find(uf_0_name[i])) != string::npos &&
	   (tmp_pos == 0 ||
	   !isalpha(tmp_sub_expr[tmp_pos-1]) &&
	   tmp_sub_expr[tmp_pos-1] != '_') &&
	   (tmp_pos+strlen(uf_0_name[i]) == tmp_sub_expr.size() ||
	   !isalpha(tmp_sub_expr[tmp_pos+strlen(uf_0_name[i])]) &&
	   tmp_sub_expr[tmp_pos+strlen(uf_0_name[i])] != '_')) {
      tmp_expr.insert(tmp_pos+pos+strlen(uf_0_name[i]),"__Fv");
      pos += tmp_pos + 4 + strlen(cmd[i]);
      tmp_sub_expr = tmp_expr.substr(pos,tmp_expr.size()-pos);
    }
  }
  for (uint i=0; i<usr_function_1_name.size(); i++) {
    string tmp_sub_expr = tmp_expr;
    pos = 0;
    while ((tmp_pos=tmp_sub_expr.find(uf_1_name[i])) != string::npos &&
	   (tmp_pos == 0 ||
	   !isalpha(tmp_sub_expr[tmp_pos-1]) &&
	   tmp_sub_expr[tmp_pos-1] != '_') &&
	   (tmp_pos+strlen(uf_1_name[i]) == tmp_sub_expr.size() ||
	   !isalpha(tmp_sub_expr[tmp_pos+strlen(uf_1_name[i])]) &&
	   tmp_sub_expr[tmp_pos+strlen(uf_1_name[i])] != '_')) {
      tmp_expr.insert(tmp_pos+pos+strlen(uf_1_name[i]),"__Fd");
      pos += tmp_pos + 4 + strlen(cmd[i]);
      tmp_sub_expr = tmp_expr.substr(pos,tmp_expr.size()-pos);
    }
  }
  for (uint i=0; i<usr_function_2d_name.size(); i++) {
    string tmp_sub_expr = tmp_expr;
    pos = 0;
    while ((tmp_pos=tmp_sub_expr.find(uf_2d_name[i])) != string::npos &&
	   (tmp_pos == 0 ||
	   !isalpha(tmp_sub_expr[tmp_pos-1]) &&
	   tmp_sub_expr[tmp_pos-1] != '_') &&
	   (tmp_pos+strlen(uf_2d_name[i]) == tmp_sub_expr.size() ||
	   !isalpha(tmp_sub_expr[tmp_pos+strlen(uf_2d_name[i])]) &&
	   tmp_sub_expr[tmp_pos+strlen(uf_2d_name[i])] != '_')) {
      tmp_expr.insert(tmp_pos+pos+strlen(uf_2d_name[i]),"__Fdd");
      pos += tmp_pos + 6 + strlen(cmd[i]);
      tmp_sub_expr = tmp_expr.substr(pos,tmp_expr.size()-pos);
    }
  }
  for (uint i=0; i<usr_function_2p_name.size(); i++) {
    string tmp_sub_expr = tmp_expr;
    pos = 0;
    while ((tmp_pos=tmp_sub_expr.find(uf_2p_name[i])) != string::npos &&
	   (tmp_pos == 0 ||
	   !isalpha(tmp_sub_expr[tmp_pos-1]) &&
	   tmp_sub_expr[tmp_pos-1] != '_') &&
	   (tmp_pos+strlen(uf_2p_name[i]) == tmp_sub_expr.size() ||
	   !isalpha(tmp_sub_expr[tmp_pos+strlen(uf_2p_name[i])]) &&
	   tmp_sub_expr[tmp_pos+strlen(uf_2p_name[i])] != '_')) {
      tmp_expr.insert(tmp_pos+pos+strlen(uf_2p_name[i]),"__FPvT0");
      pos += tmp_pos + 6 + strlen(cmd[i]);
      tmp_sub_expr = tmp_expr.substr(pos,tmp_expr.size()-pos);
    }
  }
  for (uint i=0; i<usr_function_2_name.size(); i++) {
    string tmp_sub_expr = tmp_expr;
    pos = 0;
    while ((tmp_pos=tmp_sub_expr.find(uf_2_name[i])) != string::npos &&
	   (tmp_pos == 0 ||
	   !isalpha(tmp_sub_expr[tmp_pos-1]) &&
	   tmp_sub_expr[tmp_pos-1] != '_') &&
	   (tmp_pos+strlen(uf_2_name[i]) == tmp_sub_expr.size() ||
	   !isalpha(tmp_sub_expr[tmp_pos+strlen(uf_2_name[i])]) &&
	   tmp_sub_expr[tmp_pos+strlen(uf_2_name[i])] != '_')) {
      tmp_expr.insert(tmp_pos+pos+strlen(uf_2_name[i]),"__FdPv");
      pos += tmp_pos + 6 + strlen(cmd[i]);
      tmp_sub_expr = tmp_expr.substr(pos,tmp_expr.size()-pos);
    }
  }

// call built-in and external variables...
  for (uint i=1; i<=num_coor; i++) {
    string tmp_sub_expr = tmp_expr;
    pos = 0;
    while ((tmp_pos=tmp_sub_expr.find(cmd[i])) != string::npos &&
	   (tmp_pos == 0 ||
	    !isalpha(tmp_sub_expr[tmp_pos-1]) &&
	    tmp_sub_expr[tmp_pos-1] != '_') &&
	   (tmp_pos+strlen(cmd[i]) == tmp_sub_expr.size() ||
	    !isalpha(tmp_sub_expr[tmp_pos+strlen(cmd[i])]) &&
	    tmp_sub_expr[tmp_pos+strlen(cmd[i])] != '_')) {
      if (!is_overloaded(cmd[i]))
	if (cmd[i] == cmd[FI_SELF]) {
	  tmp_expr.replace(tmp_pos+pos,strlen(cmd[i]),"forint_dlf()");
	  pos += tmp_pos + strlen("forint_dlf()");
	} else {
	  tmp_expr.insert(tmp_pos+pos+strlen(cmd[i]),"()");
	  pos += tmp_pos + 2 + strlen(cmd[i]);
	}
      else {
	tmp_expr.insert(tmp_pos+pos,"::");
	pos += tmp_pos + 2 + strlen(cmd[i]);
      }
      tmp_sub_expr = tmp_expr.substr(pos,tmp_expr.size()-pos);
    }
  }

  if (angle_unit != FI_RADIAN)
// change angle unit...
  for (uint i=FI_SIN; i<FI_SINH; i++) {
    string tmp_sub_expr = tmp_expr;
    pos = 0;
    while ((tmp_pos=tmp_sub_expr.find(cmd[i])) != string::npos &&
	   (tmp_pos == 0 ||
	    !isalpha(tmp_sub_expr[tmp_pos-1]) &&
	    tmp_sub_expr[tmp_pos-1] != '_') &&
	   (tmp_pos+strlen(cmd[i]) == tmp_sub_expr.size() ||
	    !isalpha(tmp_sub_expr[tmp_pos+strlen(cmd[i])]) &&
	    tmp_sub_expr[tmp_pos+strlen(cmd[i])] != '_')) {
      uint k=0;
      while (tmp_sub_expr[tmp_pos+strlen(cmd[i])+k] == ' ' &&
	     tmp_pos+strlen(cmd[i])+k < tmp_sub_expr.size()) ++k;
      if (tmp_pos+strlen(cmd[i])+k < tmp_sub_expr.size() &&
	  tmp_sub_expr[tmp_pos+strlen(cmd[i])+k] == '(' &&
	  !is_overloaded_func(cmd[i])) {
	if (i <= FI_ASIN) {
	  uint l = k+1;
	  uint coun = 1;
	  while (tmp_pos+strlen(cmd[i])+l < tmp_sub_expr.size()) {
	    if (tmp_sub_expr[tmp_pos+strlen(cmd[i])+l] == '(') ++coun;
	    else if (tmp_sub_expr[tmp_pos+strlen(cmd[i])+l] == ')') --coun;
	    if (!coun) break;
	    ++l;
	  }
	  tmp_expr.insert(tmp_pos+pos+strlen(cmd[i])+k,"(");
	  if (angle_unit == FI_DEGREE)
	    tmp_expr.insert(tmp_pos+pos+strlen(cmd[i])+l+1,")*M_PI/180.");
	  else
	    tmp_expr.insert(tmp_pos+pos+strlen(cmd[i])+l+1,")*M_PI/200.");
	  pos += tmp_pos + strlen("()*M_PI/180.") + strlen(cmd[i]);
	} else {
	  uint l = k+1;
	  uint coun = 1;
	  while (tmp_pos+strlen(cmd[i])+l < tmp_sub_expr.size()) {
	    if (tmp_sub_expr[tmp_pos+strlen(cmd[i])+l] == '(') ++coun;
	    else if (tmp_sub_expr[tmp_pos+strlen(cmd[i])+l] == ')') --coun;
	    if (!coun) break;
	    ++l;
	  }
	  tmp_expr.insert(tmp_pos+pos,"(");
	  if (angle_unit == FI_DEGREE)
	    tmp_expr.insert(tmp_pos+pos+strlen(cmd[i])+l+2,"*180./M_PI)");
	  else
	    tmp_expr.insert(tmp_pos+pos+strlen(cmd[i])+l+2,"*200./M_PI)");
	  pos += tmp_pos + strlen("()*180./M_PI") + strlen(cmd[i]);
	}
      }
      tmp_sub_expr = tmp_expr.substr(pos,tmp_expr.size()-pos);
    }
  }

// replace non-decimal numbers in bash notation...
  for (uint i=0; i<tmp_expr.size(); i++) {
    if (tmp_expr[i] == '#') {
      uint j=i-1;
      while (j>=0 && isdigit(tmp_expr[j])) --j;
      uint k=i+1;
      while (isalnum(tmp_expr[k])) ++k;
      uint base            = strtol(tmp_expr.c_str()+j+1,0,10);
      unsigned long number = strtol(tmp_expr.c_str()+i+1,0,base);
      char buf[FINT_NUMBER_BUFFER];
      ostrstream ostr(buf,FINT_NUMBER_BUFFER);
      ostr << number << ends;
      tmp_expr.replace(j+1,k,buf);
      i=k;
    }
  }

  if (!old_new_name.size()) {
    fprintf(dlf_file,"\ndouble FInt::forint::\nforint_dlf (void)\n{\n");
    uint i;
    for (i=tmp_expr.size()-1; i; i--)
      if (tmp_expr[i] == ';')
	break;
    if (i) {
      fprintf(dlf_file,"  %s;\n",
	      tmp_expr.substr(0,i).c_str());
      fprintf(dlf_file,"  return %s;\n}",
	      tmp_expr.substr(i+1,tmp_expr.size()-(i+1)).c_str());
    } else
      fprintf(dlf_file,"  return %s;\n}", tmp_expr.c_str());
  } else {
    fprintf(dlf_file,
	    "\ndouble FInt::forint::\nforint_dlf (void)\n{\n");
    for (map<string,string>::iterator it=old_new_name.begin();
	 it != old_new_name.end(); it++) {
      if (!is_overloaded(it->first.c_str()))
	fprintf(dlf_file, "  Llong %s = Llong(%s());\n",
		(char*)(it->second.c_str()),(char*)(it->first.c_str()));
      else
	fprintf(dlf_file, "  Llong %s = Llong(::%s);\n",
		(char*)(it->second.c_str()),(char*)(it->first.c_str()));
    }
    uint i;
    for (i=tmp_expr.size()-1; i; i--)
      if (tmp_expr[i] == ';')
	break;
    if (i) {
      fprintf(dlf_file,"  %s;\n",
	      tmp_expr.substr(0,i).c_str());
      fprintf(dlf_file,"  double ret_val = %s;\n",
	      tmp_expr.substr(i+1,tmp_expr.size()-(i+1)).c_str());
    } else
      fprintf(dlf_file,"  double ret_val = %s;\n", tmp_expr.c_str());

    for (map<string,string>::iterator it=old_new_name.begin();
	 it != old_new_name.end(); it++) {
      if (!is_overloaded(it->first.c_str()))
	fprintf(dlf_file, "  %s() = double(%s);\n",
		(char*)(it->first.c_str()),(char*)(it->second.c_str()));
      else
	fprintf(dlf_file, "  ::%s = double(%s);\n",
		(char*)(it->first.c_str()),(char*)(it->second.c_str()));
    }
    fprintf(dlf_file,"  return ret_val;\n");
    fprintf(dlf_file,"}\n");
  }
  fclose(dlf_file);

  char* tmpd = getenv("FORINT_INCL_DIR");
  string incl_dir = (tmpd)
    ? (string("-I")+string(tmpd)).c_str()
    : "-I./"; // dummy
  pid_t pid;
  int status;
  uint opt_size = (dlf_opt) ? dlf_opt->size() : 0;
  char** p = new char*[9 + opt_size];
  p[0] = "g++";
  p[1] = "-O6";
  p[2] = "-shared";
  p[3] = "-I../include";
  p[4] = (char*)incl_dir.c_str();
  p[5] = cc_name;
  p[6] = "-o";
  p[7] = so_name;
  for (uint i=0; i<opt_size; i++)
    p[8 + i] = (*dlf_opt)[i];
  p[8 + opt_size] = 0;
  if ((pid = vfork()) < 0) {
    fputs ("\nforint: vfork() error\n", stderr);
    fputs (strerror(errno), stderr);
    error_code = 1000;
    return error_code;
  } else if (pid == 0)
    if (execvp("g++",p) == -1) {
      //if (execlp("g++","g++","-O6","-shared","-I../include",incl_dir.c_str(),
      //       cc_name,"-o",so_name,0) == -1) {
      fputs ("\nforint: execvp() error\n", stderr);
      fputs (strerror(errno), stderr);
      error_code = 1000;
      return error_code;
    }
  if (waitpid(pid, &status, 0) != pid) {
    fputs (strerror(errno), stderr);
    fputs ("\nforint: wait() error\n", stderr);
    error_code = 1000;
    return error_code;
  }
  free(p);
  FILE* so_fd = fopen(so_name,"r");
  if (!so_fd) {
    fputs ("\nforint: a compilation error\n", stderr);
    error_code = 1000;
    return error_code;
  }
  fclose(so_fd);

  return 0;
}

// clean all structures...
void forint::
clean(void)
{
  r_action.del();
  s_action.del();
  number.del();
  var_num.del();
  poin_num.del();
  poin_num_level.del();
  usr_function_0_num.del();
  usr_function_1_num.del();
  usr_function_2d_num.del();
  usr_function_2p_num.del();
  usr_function_2_num.del();
  offsets.del();
  b_cast_pos.clear();
  e_cast_pos.clear();
  d_b_cast_pos.clear();
  d_e_cast_pos.clear();
  if (math_expression) {
    free(math_expression);
    math_expression = 0;
  }
  if (r_prog) {
    for (uint i=0; i<r_action.size(); i++)
      if (r_prog[i])
	free(r_prog[i]);
    free(r_prog);
    r_prog = 0;
  }
  if (s_prog) {
    for (uint i=0; i<s_action.size(); i++)
      if (s_prog[i])
	free(s_prog[i]);
    free(s_prog);
    s_prog = 0;
  }
  if (dlfunc_lib &&
      (remove(dlfunc_so_name) == -1 ||
       remove(dlfunc_cc_name) == -1)) {
    fputs ("\nforint: remove() error\n", stderr);
    fputs (strerror(errno), stderr);
  }
  if (dlfunc_lib) {
    dlclose(dlfunc_lib);
    dlfunc_lib = 0;
    dl_function    = 0;
  }
  if (dlfunc_cc_name) {
    free(dlfunc_cc_name);
    dlfunc_cc_name = 0;
  }
  if (dlfunc_so_name) {
    free(dlfunc_so_name);
    dlfunc_so_name = 0;
  }
}

// free all captioned dynamic memory
void forint::
del(void)
{
  error_code = 0; 
  if (math_expression) {
    free(math_expression);
    math_expression = 0;
  }
  if (dlfunc_lib &&
      (remove(dlfunc_so_name) == -1 ||
       remove(dlfunc_cc_name) == -1)) {
    fputs ("\nforint: remove() error\n", stderr);
    fputs (strerror(errno), stderr);
  }
  if (dlfunc_lib) {
    dlclose(dlfunc_lib);
    dlfunc_lib = 0;
  }
  if (dlfunc_cc_name) {
    free(dlfunc_cc_name);
    dlfunc_cc_name = 0;
  }
  if (dlfunc_so_name) {
    free(dlfunc_so_name);
    dlfunc_so_name = 0;
  }
  if (r_prog) {
    for (uint i=0; i<r_action.size(); i++) if (r_prog[i]) free(r_prog[i]);
    free(r_prog);
    r_prog = 0;
  }
  if (s_prog) {
    for (uint i=0; i<s_action.size(); i++) if (s_prog[i]) free(s_prog[i]);
    free(s_prog);
    s_prog = 0;
  }
  for (uint k=0; k<poin_offset.size(); k++)
    if (poin_offset.getPtr()[k])
      free(poin_offset.getPtr()[k]);
  poin_offset.del();
  for (uint k=0; k<poin_dim_size.size(); k++)
    if (poin_dim_size.getPtr()[k])
      free(poin_dim_size.getPtr()[k]);
  poin_dim_size.del();
  for (uint i=0; i<var_name.size(); i++)
    if (var_name.getPtr()[i]) free(var_name.getPtr()[i]);
  var_name.del();
  for (uint i=0; i<poin_name.size(); i++)
    if (poin_name.getPtr()[i]) free(poin_name.getPtr()[i]);
  poin_name.del();
  for (uint i=0; i<usr_function_0_name.size(); i++)
    if (usr_function_0_name.getPtr()[i]) free(usr_function_0_name.getPtr()[i]);
  usr_function_0_name.del();
  for (uint i=0; i<usr_function_1_name.size(); i++)
    if (usr_function_1_name.getPtr()[i]) free(usr_function_1_name.getPtr()[i]);
  usr_function_1_name.del();
  for (uint i=0; i<usr_function_2d_name.size(); i++)
    if (usr_function_2d_name.getPtr()[i]) free(usr_function_2d_name.getPtr()[i]);
  usr_function_2d_name.del();
  for (uint i=0; i<usr_function_2p_name.size(); i++)
    if (usr_function_2p_name.getPtr()[i]) free(usr_function_2p_name.getPtr()[i]);
  usr_function_2p_name.del();
  for (uint i=0; i<usr_function_2_name.size(); i++)
    if (usr_function_2_name.getPtr()[i]) free(usr_function_2_name.getPtr()[i]);
  usr_function_2_name.del();
}

int forint::
copy(const forint& t)
{
  locale = t.locale;
  math_expression = (char*)malloc(strlen(t.math_expression));
  strcpy(math_expression,t.math_expression);
  flag_of_built_in_var_access = t.flag_of_built_in_var_access;
  flag_of_extra_built_in_var_access = t.flag_of_extra_built_in_var_access;
  angle_unit = t.angle_unit;
  flag_of_ctrl_statement_access = t.flag_of_ctrl_statement_access;
  clearing_flag = t.clearing_flag;
  is_while = t.is_while;
  dlfunc_cc_name = (char*)malloc(strlen(t.dlfunc_cc_name));
  strcpy(dlfunc_cc_name,t.dlfunc_cc_name);
  dlfunc_so_name = (char*)malloc(strlen(t.dlfunc_so_name));
  strcpy(dlfunc_so_name,t.dlfunc_so_name);
  dlfunc_lib = dlopen (dlfunc_so_name, RTLD_LAZY);
  r_action       = t.r_action;
  r_action_p     = r_action.getPtr();
  s_action       = t.s_action;
  s_action_p     = s_action.getPtr();
  number         = t.number;
  number_p       = number.getPtr();
  variable       = t.variable;
  variable_p     = variable.getPtr();
  var_num        = t.var_num;
  var_num_p      = var_num.getPtr();
  var_const_flag = t.var_const_flag;
  pointer          = t.pointer;
  pointer_p        = pointer.getPtr();
  poin_type        = t.poin_type;
  
  for (uint k=0; k<t.poin_offset.size(); k++)
    if (t.poin_offset.getPtr()[k]) {
      uint* tmp = (uint*)malloc(t.poin_type.getPtr()[k].num_dims*sizeof(uint));
      memcpy(tmp,
	     t.poin_offset.getPtr()[k],
	     t.poin_type.getPtr()[k].num_dims*sizeof(uint));
      poin_offset.push_back(tmp);
    }
  for (uint k=0; k<t.poin_dim_size.size(); k++)
    if (t.poin_dim_size.getPtr()[k]) {
      uint* tmp = (uint*)malloc(t.poin_type.getPtr()[k].num_dims*sizeof(uint));
      memcpy(tmp,
	     t.poin_dim_size.getPtr()[k],
	     t.poin_type.getPtr()[k].num_dims*sizeof(uint));
      poin_dim_size.push_back(tmp);
    }
  for (uint i=0; i<t.var_name.size(); i++)
    if (t.var_name.getPtr()[i])
      var_name.push_back(strdup(t.var_name.getPtr()[i]));
  for (uint i=0; i<t.poin_name.size(); i++)
    if (t.poin_name.getPtr()[i])
      poin_name.push_back(strdup(t.poin_name.getPtr()[i]));
  for (uint i=0; i<t.usr_function_0_name.size(); i++)
    if (t.usr_function_0_name.getPtr()[i])
      usr_function_0_name.push_back(strdup(t.usr_function_0_name.getPtr()[i]));
  for (uint i=0; i<t.usr_function_1_name.size(); i++)
    if (t.usr_function_1_name.getPtr()[i])
      usr_function_1_name.push_back(strdup(t.usr_function_1_name.getPtr()[i]));
  for (uint i=0; i<t.usr_function_2d_name.size(); i++)
    if (t.usr_function_2d_name.getPtr()[i])
      usr_function_2d_name.push_back(strdup(t.usr_function_2d_name.getPtr()[i]));
  for (uint i=0; i<t.usr_function_2p_name.size(); i++)
    if (t.usr_function_2p_name.getPtr()[i])
      usr_function_2p_name.push_back(strdup(t.usr_function_2p_name.getPtr()[i]));
  for (uint i=0; i<t.usr_function_2_name.size(); i++)
    if (t.usr_function_2_name.getPtr()[i])
      usr_function_2_name.push_back(strdup(t.usr_function_2_name.getPtr()[i]));

  poin_num         = t.poin_num;
  poin_num_p       = poin_num.getPtr();
  poin_num_level   = t.poin_num_level;
  poin_num_level_p = poin_num_level.getPtr();
  usr_function_0        = t.usr_function_0;
  usr_function_0_p      = usr_function_0.getPtr();
  usr_function_0_num    = t.usr_function_0_num;
  usr_function_0_num_p  = usr_function_0_num.getPtr();
  usr_function_1        = t.usr_function_1;
  usr_function_1_p      = usr_function_1.getPtr();
  usr_function_1_num    = t.usr_function_1_num;
  usr_function_1_num_p  = usr_function_1_num.getPtr();
  usr_function_2d       = t.usr_function_2d;
  usr_function_2d_p     = usr_function_2d.getPtr();
  usr_function_2d_num   = t.usr_function_2d_num;
  usr_function_2d_num_p = usr_function_2d_num.getPtr();
  usr_function_2p           = t.usr_function_2p;
  usr_function_2p_p         = usr_function_2p.getPtr();
  usr_function_2p_poin_type = t.usr_function_2p_poin_type;
  usr_function_2p_num       = t.usr_function_2p_num;
  usr_function_2p_num_p     = usr_function_2p_num.getPtr();
  usr_function_2 = t.usr_function_2;
  usr_function_2_p = usr_function_2.getPtr();
  usr_function_2_poin_type = t.usr_function_2_poin_type;
  usr_function_2_num = t.usr_function_2_num;
  usr_function_2_num_p = usr_function_2_num.getPtr();
  r_prog = 0;
  s_prog = 0;
  offsets = t.offsets;
  offsets_p = offsets.getPtr();
  b_cast_pos = t.b_cast_pos;
  e_cast_pos = t.e_cast_pos;
  b_decomposed_string = 0;
  d_b_cast_pos = t.d_b_cast_pos;
  d_e_cast_pos = t.d_e_cast_pos;
  break_flag = t.break_flag;
  error_code = t.error_code;
  return 0;
}

forint::
forint(const forint& t) : c(t.c) { copy(t); }

// ATTENTION: mssg& doesn't copied !!!
forint& forint::
operator = (const forint& t)
{
  if (this != &t) {
    del();
    copy(t);
  }
  return *this;
}

}
